-- Structure :   ["key"][ [dialogPages],lastPageIndex,{Functions to call on end {function,arg1,arg2}} }
WowkemonChatFrame = nil
local dialogPage = 1;
local activeKey = nil;

WowkemonChatFrameBackdrop =
{
    bgFile = nil, --"Interface\\Tooltips\\UI-Tooltip-Background",
    edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
    tile = false, tileSize = 16, edgeSize = 16,
    insets = { left = 3, right = 3, top = 5, bottom = 3 }
}
-- GIVE QUEST TYPE FUNCTIONS CALLED AT THE END OF APPROPRIATE MESSAGES.
-- QUEST STRUCTURE DEFINED HERE. [1] = type, [2] = target zone, [3] target to visit / capture [4] = amount required (default 1 in travel), [5] Descriptive text, [6] complete status
function giveWowkemonCaptureQuest(wowkemon,amountToCap)
  local zone = GetZoneText()
  if wowkemon == nil or amountToCap == nil then
    print("|cffFFff00  Wowkemon Error: Quest Logic Error -  Missing Details |r");
  else
    local structure = {"capture",zone,wowkemon,amountToCap,"Capture "..amountToCap.." "..wowkemon.." in "..zone,0}
    table.insert(WowkemonPlayerData["quests"],structure)
    print("|cffFFff00 Wowkemon: Quest Added |r");
  end
end

function giveWowkemonTravelQuest(goal,targetNPC) -- Travel quest input are Zone name & Target NPC Type. goal can be specific zone name or "city" for any major city.
  local endTarget = goal
  if goal == "city" then
    endTarget = "any City"
  end
  local structure = {"travel",endTarget,targetNPC[1],1,"Deliver the package to "..targetNPC[1].." in "..goal,targetNPC[2]}
  table.insert(WowkemonPlayerData["quests"],structure)
end

function checkTravelQuestsForInteractTarget(type)
local criteriaComplete = false;
local currentZone = wowkemonCheckIfInCity(GetZoneText())
  for quest in pairs(WowkemonPlayerData["quests"]) do
    if WowkemonPlayerData["quests"][quest][1] == "travel" and WowkemonPlayerData["quests"][quest][2] == currentZone and WowkemonPlayerData["quests"][quest][3] == type then
      criteriaComplete = true;
      CreateRadarMessageButton(WowkemonPlayerData["quests"][quest][6]);
      table.remove(WowkemonPlayerData["quests"],quest)

  end
end
  if criteriaComplete == true then
    print("|cffFFff00 Wowkemon quest complete!|r");
  end
end

function wowkemonCheckIfInCity(currentZone)
  local returnZone = nil;
  if currentZone == "Stormwind City" or "City of Ironforge" or "Darnassus" or "Orgrimmar" or "Undercity" or "Thunderbluff" then
    returnZone = "any City"
    return returnZone
  else
    return currentZone
  end
end



wowkemonDialog = {

["tutorial"] = { {"So you're the new Wowkemon trainer huh? Welcome to the club. My names GenericPlaceHolderName, I've been tasked with showing you around. So, let's get started.","I guess by now you've already figured out how to read new messages. Now that you've registered your Trainer ID, if anyone needs to get in touch, they'll drop you a message just like I did. Your mini CraftBoy will flash blue when you have a message.","While you're out in the World of Warcaft your Wowkedar will alert you to any nearby Wowkemon. If it turns red, it means a Wowkemon is available for you to capture! Click the alert to launch the capture event.", "I've attached 5 Capture cubes to this message. Use them wisely!  "},4,{{WowkemonDispatchMultiFunction,{WowkemonAddItem, function () tutorialStatuses[3] = 1 end},{{"Capture Cube",5},{"Capture Cube",5}}} } },

["tutorial2"] = { {"You found a wowkemon! Use your capture cubes to catch it! Make sure you time your click carefully! Better timing means higher chances of capturing it!","Landing your shot is only half the battle, though. Once caught, the wowkemon has a 3 second window where it could break free! Your chances are lowered drastically if the Wowkemon is much higher level than you.","You'll need capture cubes to catch a wowkemon, so make sure to keep stocked! There are a few ways to gain capture cubes, most of which involve interacting with certain people or objects in game.","Now catch that Wowkemon!"},4,{{function() tutorialStatuses[3] = 2; end,nil,nil}} },

["tutorial3"] = { {"You caught one! Awesome! Your wowkedex tracks all the Wowkemon you've captured along with other useful information. Type /wowkemon or click on the mini-CraftBoy to open your CraftBoy and see your wowkedex!","Your CraftBoy shows you all sorts of information.  You can see your progress as a trainer, keep track of the Wowkemon you've captured and get a breakdown of any points of interest in your current zone! Points of interest can reward items or start quests so don't forget to drop in!"},2,{{function() tutorialStatuses[3] = 3; end,nil,nil}} },

["mailtutorial"] = { {"Dear valued Trainer, \nThank you for registering for your Trainer ID, and welcome to the Club! As part of your membership, we will regularly send you supplies to help you in your journey.","Unfortunately, mail delivery is pretty archaic around these parts, so in order to maintain our high level of customer service, we have sent supplies to all local mailboxes so that you're never too far from those crucial supplies! Aren't we nice!","Items are posted daily, but don't expect them to sit in the mailroom for long! Naturally, due to the amount we send out, we recall all uncollected mail at the end of each day, so don't dally! \nSincerely, MailWritingGuy"},3,{{nil}}},

["innkeepertutorial"] = {{"Hi there! I'm the local innkeeper and lead trainer in this zone. You'll find that most innkeepers run their own Wowkemon Arenas.","Of course, for obvious reasons, we don't like to talk about it, so let's just keep this conversation in the Wowkedex, yes?","You should check in with us from time to time, we may have some errands for strong legs like yours! Take some cubes as a gesture of good will. I hope we can work together in the future. "},3,{{WowkemonDispatchMultiFunction,{WowkemonAddItem,WowkemonAddItem},{{"Capture Cube",3},{"Capture Cube",5}}} } },

["kill quest"] = { {"As a trainer, you've got to be on your toes and sharpening your skill often. Prove to me you've got what it takes to be a trainer! Go capture a wowkemon in "..GetZoneText()},1,{{giveWowkemonCaptureQuest,"wowkemon",1}} },

["travel quest"] = { {"My monthly arena tax is due. The Battlemasters are on my back and are threatening to send collectors around, but I don't have the time to deliver the payment right now. You can't turn your back on a drunk for a second, y'know?"," Could you do it for me? You can deliver it to any City Battlemaster!"},2,{{giveWowkemonTravelQuest,"city",{"battlemaster","battlemasterTravelQuestComplete"} } }
},

["battlemasterTravelQuestComplete"] = { {"Ah, payments due. As always "..WowkemonPlayerClass..", if anbody asks, you've never heard of <Gym Name>! Here's something for your trouble. Don't worry, I'll pass on the cost to their next bill."},1,{{selectRandomMailLoot,nil,nil}} },

}


function CreateWowkedexChatFrame(key)
  activeKey = key;
  if WowkemonChatFrame == nil then
    WowkemonChatFrame = CreateFrame("Frame","wowkemonDialogFrame");
    WowkemonChatFrame:SetBackdrop(WowkemonChatFrameBackdrop)
    WowkemonChatFrame:SetFrameLevel(6)
    WowkemonChatFrame:SetHeight(WowkemonMenuScreenWindow:GetHeight()-25)
    WowkemonChatFrame:SetWidth(WowkemonMenuScreenWindow.contentPanel:GetWidth() - 25)
    WowkemonChatFrame:SetPoint("CENTER",WowkemonMenuScreenWindow.contentPanel,"CENTER")
    WowkemonChatFrame.BG = WowkemonChatFrame:CreateTexture(nil,"BACKGROUND",0)
    WowkemonChatFrame.BG:SetColorTexture(0,0,0,1)
    WowkemonChatFrame.BG:SetHeight(WowkemonChatFrame:GetHeight() -5)
    WowkemonChatFrame.BG:SetWidth(WowkemonChatFrame:GetWidth() -5)
    WowkemonChatFrame.BG:SetPoint("CENTER",WowkemonMenuScreenWindow,"CENTER")
    WowkemonChatFrame:EnableMouse(true)
  --  WowkemonChatFrame:SetMovable(true)
--    WowkemonChatFrame:RegisterForDrag("LeftButton")
--    WowkemonChatFrame:SetScript("OnDragStart", WowkemonChatFrame.StartMoving)
--    WowkemonChatFrame:SetScript("OnDragStop",WowkemonChatFrame.StopMovingOrSizing)
    WowkemonChatFrame:SetPoint("CENTER",WowkemonMenuScreenWindow,"CENTER",0,0);
    WowkemonChatFrame.textContent = WowkemonChatFrame:CreateFontString(nil,"OVERLAY","GameFontNormal")
    WowkemonChatFrame.textContent:SetWidth(WowkemonChatFrame:GetWidth() - 20);
    WowkemonChatFrame.textContent:SetHeight(90);
    WowkemonChatFrame.textContent:SetPoint("TOPLEFT",WowkemonChatFrame,"TOPLEFT",10,-50)
    WowkemonChatFrame.textContent:SetJustifyH("LEFT");
    WowkemonChatFrame.textContent:SetJustifyV("TOP");
    WowkemonChatFrame.textContent:SetMaxLines(50)
    -- WowkemonChatFrame.textContent:SetWordWrap(enable)
    WowkemonChatFrame.textContent:SetNonSpaceWrap(true)
      WowkemonChatFrame.Button = CreateFrame("Button","wowkemonchatframebtn",WowkemonChatFrame,"UIPanelButtonTemplate")
      WowkemonChatFrame.Button:SetPoint("BOTTOMRIGHT",WowkemonChatFrame,"BOTTOMRIGHT",-20,10)
      WowkemonChatFrame.Button:SetScript("OnClick",function ()  WowkemonMenuCoreOptions:Hide()  WowkemonChatFrame.Button:Hide() dialogPage = dialogPage + 1; updateDialogButtonScript(); end)
else
  WowkemonChatFrame:Show()
end
    local delay = 0.1
    local delayMultiplier = 1;
    local length = string.len(wowkemonDialog[activeKey][1][dialogPage])
    local distance = 1;
    for i = 1,length do
      distance = distance + 1
      Wowkemon__wait((0.05*distance),SetWowkedexOriginPanelText,string.upper(string.sub(wowkemonDialog[activeKey][1][dialogPage],1,distance)),WowkemonChatFrame)
    end
    Wowkemon__wait((length*0.05),toggleDialogButton)
    if dialogPage < (wowkemonDialog[activeKey][2]) then
      WowkemonChatFrame.Button:SetText("Next");
    else
      WowkemonChatFrame.Button:SetText("Close");
    end
      WowkemonChatFrame.Button:Hide()
    end


function nextChatFrame(targetedFrame, currentPage)
end

function dialogtestfunc()
  print("yup")
end

function updateDialogButtonScript()
    if dialogPage <= wowkemonDialog[activeKey][2] then
        local delay = 0.05
        local delayMultiplier = 1;
        local length = string.len(wowkemonDialog[activeKey][1][dialogPage])
        local distance = 1;
        for i = 1,length do
          distance = distance + 1
          Wowkemon__wait((0.05*distance),SetWowkedexOriginPanelText,string.upper(string.sub(wowkemonDialog[activeKey][1][dialogPage],1,distance)),WowkemonChatFrame)
          end
          Wowkemon__wait((length*0.05),toggleDialogButton)
end
      if    dialogPage <  wowkemonDialog[activeKey][2] then
       WowkemonChatFrame.Button:SetText("Next");
     elseif  dialogPage ==  wowkemonDialog[activeKey][2] then
        WowkemonChatFrame.Button:SetText("Close");
      else
            if wowkemonDialog[activeKey][3][1][1] ~= nil then
          for efunc in pairs(wowkemonDialog[activeKey][3]) do
          wowkemonDialog[activeKey][3][efunc][1](wowkemonDialog[activeKey][3][efunc][2],wowkemonDialog[activeKey][3][efunc][3])
         end
       else
      --  func();
        end
          WowkemonChatFrame:Hide()
          if CaptureWindowLive == false then
        --  openMainWowkedexPanel()
        end
          WowkemonMessageLive = false;
          dialogPage = 1;
       end
     end

function toggleDialogButton()
  WowkemonChatFrame.Button:Show()
end

function WowkemonCompleteTutorialType(index)
tutorialStatuses[index] = true;
end
