WowkemonFirstTimeLoaded = true;
WowkemonTutorialStage = 0;
tutorialStatuses = {false,false,nil} -- [1] = Mail Tutorial,  [2] = Inkeeper Tutorial [3] General intro tutorial (numbered stages)
WowkemonInkeeperTutorialComplete = false
WowkemonMailTutorialComplete = false;
selectedPVPWowkemon = "Wowkachu";
WowkemonPlayerData = {
  ["Facing"] = 0,
  ["level"] = 1,
  ["XP"] = 0,
  ["Capture Cube"] = 0,
  ["Wowkedex"] = {}, -- [1] = candy,  [2] = totaltimescaptured [3] = highest level
  ["quests"] = {}
}
visitedMailboxes = {}
WowkemonDayLoot = {nil,nil}

WowkemonPlayerClass = UnitClass("player");

WowkemonDebugShowSpawnChance = false;

if round == nil then
round = function (num, numDecimalPlaces)
  if num ~= 0 then
  local mult = 10^(numDecimalPlaces or 0)
  return math.floor(num * mult + 0.5) / mult
else return 0;
end
end
end
-- root directory
WDir = "Interface\\Addons\\Wowkemon_Classic"

ZoneTextures = {
  ["nozone"] = WDir.."\\resources\\textures\\zones\\imagePending.tga",
  ["Stormwind City"] = WDir.."\\resources\\textures\\zones\\stormwind.tga",
  ["Loch Modan"] = WDir.."\\resources\\textures\\zones\\lochmodan.tga",
  ["Ironforge"] = WDir.."\\resources\\textures\\zones\\ironforge.tga",
  ["Westfall"] = WDir.."\\resources\\textures\\zones\\westfall.tga",
  ["Duskwood"] = WDir.."\\resources\\textures\\zones\\duskwood.tga"
}

WindowLocations = {
  ["WowkesenseFrame"] = {0,0}

  }
-- Spawn timers
LastSpawnRefreshTime = 0;
  local RespawnTriggerTime = 600;
-- Template Backdrops

CaptureFrameBackdrop =
{
    bgFile = "",
    edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
    tile = false, tileSize = 16, edgeSize = 16,
    insets = { left = 3, right = 3, top = 5, bottom = 3 }
}





-- SLASH COMMANDS
SLASH_WowkemonCmd1 = "/wowkemon"
SlashCmdList["WowkemonCmd"] = function(msg, editbox)
  local _, _, cmd, args = string.find(msg, "%s?(%w+)%s?(.*)")
 if cmd == "spawn" and args ~= "" then
   print("Spawning Wowkemon "..args);
   SpawnAtPlayerLocation(args)
 elseif cmd == "spawn" then
   print("Spawning random Wowkemon");
   SpawnAtPlayerLocation()
   -- Handle adding of the contents of rest... to something.
 elseif cmd == "remove" and args ~= "" then
   print("removing " .. args)
   -- Handle removing of the contents of rest... to something.
 elseif cmd == "travelquest" then
      print("Wowkemon: Battlemaster travel quest added")
      giveWowkemonTravelQuest("city",{"battlemaster","battlemasterTravelQuestComplete"})
elseif cmd == "showspawn" then
    if args =="1" then
      WowkemonDebugShowSpawnChance = true
      print("enabled spawn chance logging")
    elseif args =="0" then
      WowkemonDebugShowSpawnChance = false;
      print("disabled spawn chance logging")
    else
        print("Unknown argument. Syntax: 0 = disable, 1 = enable ")
      end
elseif cmd =="resettutorial" then
  tutorialStatuses = {false,false,nil}
  print("Wowkemon tutorials reset")
elseif cmd =="cubes" then
  if args == "" then
    WowkemonAddItem("Capture Cube",5)
  end
 else
   -- If not handled above, display some sort of help message
openMainWowkedexPanel()
 end
end;

-- Frame Setups
local CaptureEventTime = 0;
-- Master frame: Invisible but always active to receive all Tick updates. Time sensitive events are tracked under this widget OnUpdate to ensure they are always relevant.
WowkemonMasterFrame = CreateFrame("Frame", "WowkemonMasterFrame", UIParent)
  WowkemonMasterFrame:SetHeight(1)
  WowkemonMasterFrame:SetWidth(1)
  WowkemonMasterFrame:SetPoint("TOP",0,0)
  WowkemonMasterFrame:SetScript("OnUpdate",function()
    -- Save player Direction on Tick
    WowkemonPlayerData["Facing"] = GetPlayerFacing();
    -- Check if we should trigger respawns
    if GetTime() - LastSpawnRefreshTime > RespawnTriggerTime then
      RenewSpawns();
      LastSpawnRefreshTime = GetTime();
    end

  end)
-- Wowkesense Frame:  visible frame that animates based on proximity to a Wowkemon.
WowkesenseFrame = CreateFrame("Frame","WowkesenseFrame",UIParent)
  WowkesenseFrame:SetHeight(100)
  WowkesenseFrame:SetWidth(100)
  WowkesenseFrame:SetMovable(true)
  WowkesenseFrame:EnableMouse(true)
--  WowkesenseFrame:SetBackdrop(CaptureFrameBackdrop)
  WowkesenseFrame:SetPoint("TOP",WindowLocations["WowkesenseFrame"][1],WindowLocations["WowkesenseFrame"][2])
  WowkesenseFrame:RegisterForDrag("LeftButton")
  WowkesenseFrame:SetScript("OnDragStart", WowkesenseFrame.StartMoving)
  WowkesenseFrame:SetScript("OnDragStop", function()
    -- Save new window position on drag stop
    local point, relativeTo, relativePoint, xOfs, yOfs = WowkesenseFrame:GetPoint()
    WowkesenseFrame:StopMovingOrSizing();
    WindowLocations["WowkesenseFrame"][1] = xOfs
    WindowLocations["WowkesenseFrame"][2] = yOfs
  end)
  WowkesenseFrame:SetScript("OnMouseUp", function(self,button) if button == "LeftButton" then
    WowkemonMenuBody:Show()
    openMainWowkedexPanel();
  end
  end)
  WowkesenseImage = WowkesenseFrame:CreateTexture(nil,"BACKGROUND")
  WowkesenseImage:SetPoint("CENTER");
  WowkesenseImage:SetHeight(WowkesenseFrame:GetHeight() - 5)
  WowkesenseImage:SetWidth(WowkesenseFrame:GetWidth() - 5)
  WowkesenseImage:SetTexture(WDir.."\\resources\\textures\\misc\\miniGB.tga")

  WowkesenseFrame.CaptureFrame = CreateFrame("Frame","WowkesenseCaptureAlertFrame",WowkesenseFrame)
  WowkesenseFrame.CaptureFrame:SetSize(60,55)
  -- WowkesenseFrame.CaptureFrame:SetBackdrop(CaptureFrameBackdrop)
  WowkesenseFrame.CaptureFrame:SetPoint("CENTER",WowkesenseFrame,"CENTER",0,13)
  WowkesenseFrame.CaptureFrameBtn = CreateFrame("Button","CaptureFrameBtn",WowkesenseFrame.CaptureFrame)
  WowkesenseFrame.CaptureFrameBtn:SetSize(WowkesenseFrame.CaptureFrame:GetSize())
  WowkesenseFrame.CaptureFrameBtn:SetPoint("CENTER",WowkesenseFrame.CaptureFrame,"CENTER",0,0)
  WowkesenseFrame.AlertColor = WowkesenseFrame.CaptureFrame:CreateTexture(nil,"BACKGROUND",4)
  WowkesenseFrame.AlertColor:SetHeight(WowkesenseFrame.CaptureFrameBtn:GetHeight()-5)
  WowkesenseFrame.AlertColor:SetWidth(WowkesenseFrame.CaptureFrameBtn:GetWidth()-5)
  WowkesenseFrame.AlertColor:SetPoint("CENTER",WowkesenseFrame.CaptureFrameBtn,"CENTER",0,0)
  WowkesenseFrame.CaptureFrameBtn:SetScript("OnClick", function() InitialiseCaptureEvent() WowkesenseFrame.CaptureFrame:Hide()  WowkemonMenuBody:Show()  end)
  WowkesenseFrame.CaptureFrameText = WowkesenseFrame.CaptureFrame:CreateFontString(nil,"OVERLAY","GameFontNormal");
  WowkesenseFrame.CaptureFrameText:SetPoint("CENTER")
  WowkesenseFrame.CaptureFrameText:SetText("!")
  WowkesenseCaptureAlertFrame:Hide();
-- Wowkemon Capture-event Frame
WowkemonCaptureFrame = CreateFrame("Frame","WowkemonCaptureFrame",WowkemonMenuScreenWindow)
  WowkemonCaptureFrame:SetHeight(285)
  WowkemonCaptureFrame:SetWidth(300)
  WowkemonCaptureFrame:SetBackdrop(CaptureFrameBackdrop)
  WowkemonCaptureFrame:SetPoint("CENTER",WowkemonMenuScreenWindow,0,0)
  WowkemonCaptureFrame:EnableMouse(true)
  WowkemonCaptureFrame:SetFrameLevel(3)
  WowkemonCaptureFrame:SetScript("OnUpdate", function (self, elapsed)
    if CaptureEventActive ~= true and WowkemonCubeButtonLock == false then
      CaptureEventTime = (CaptureEventTime + elapsed);
    end
    if CaptureEventTime > 1 then
      CaptureEventTime = 0;
    end
      WowkemonCaptureFrame:SetPoint("CENTER",WowkemonMenuScreenWindow,0,0)
  end)

  -- Capture event Inner Frames
    WowkemonCaptureFrame.InnerFrame = CreateFrame("Frame","WCFInnerFrame",WowkemonCaptureFrame)
      WowkemonCaptureFrame.InnerFrame:SetBackdrop(CaptureFrameBackdrop)
      WowkemonCaptureFrame.InnerFrame:SetPoint("CENTER")
      WowkemonCaptureFrame.InnerFrame:SetFrameLevel(4)
      WowkemonCaptureFrame.InnerFrame:SetHeight((WowkemonCaptureFrame:GetHeight() - 10))
      WowkemonCaptureFrame.InnerFrame:SetWidth((WowkemonCaptureFrame:GetWidth() - 10))
        -- Background Texture
      --  WowkemonCaptureFrame.BackgroundBase = WowkemonCaptureFrame.InnerFrame:CreateTexture(nil,"BACKGROUND",2);
      --  WowkemonCaptureFrame.BackgroundBase:SetWidth(WowkemonCaptureFrame.InnerFrame:GetWidth() - 5);
      --  WowkemonCaptureFrame.BackgroundBase:SetHeight(WowkemonCaptureFrame.InnerFrame:GetHeight() - 5);
      --  WowkemonCaptureFrame.BackgroundBase:SetColorTexture(0,0,0,1);
      --  WowkemonCaptureFrame.BackgroundBase:SetPoint("CENTER",0,0);
        WowkemonCaptureFrame.Background = WowkemonCaptureFrame.InnerFrame:CreateTexture(nil,"BACKGROUND",5);
        WowkemonCaptureFrame.Background:SetWidth(WowkemonCaptureFrame.InnerFrame:GetWidth() - 5);
        WowkemonCaptureFrame.Background:SetHeight(WowkemonCaptureFrame.InnerFrame:GetHeight() - 5);

        WowkemonCaptureFrame.Background:SetTexture(ZoneTextures["Duskwood"]);
        WowkemonCaptureFrame.Background:SetPoint("CENTER",0,-0);
      WowkemonCaptureFrame.Wowkemon = WowkemonCaptureFrame.InnerFrame:CreateTexture(nil,"OVERLAY");
      WowkemonCaptureFrame.Wowkemon:SetPoint("CENTER")
      WowkemonCaptureFrame.Wowkemon:SetWidth(100)
      WowkemonCaptureFrame.Wowkemon:SetHeight(100)
      WowkemonCaptureFrame.Wowkemon:SetTexture("Interface\\Addons\\Wowkemon\\resources\\textures\\wowkemon\\pikachu.tga")
      WowkemonCaptureFrame.TextLayer = CreateFrame("Frame","CaptureFrameTextLayer",WowkemonCaptureFrame)
      WowkemonCaptureFrame.TextLayer:SetSize(WowkemonCaptureFrame:GetSize())
      WowkemonCaptureFrame.WowkemonDetailText = WowkemonCaptureFrame.TextLayer:CreateFontString(nil,"OVERLAY","GameFontNormal")
      WowkemonCaptureFrame.WowkemonDetailText:SetPoint("TOP",WowkemonCaptureFrame,"TOP",0,-10)
      WowkemonCaptureFrame.WowkemonDetailText:SetText("Wowkemon Info")
      WowkemonCaptureFrame.CaptureTextClickResult = WowkemonCaptureFrame.TextLayer:CreateFontString(nil,"OVERLAY","GameFontNormal")
      WowkemonCaptureFrame.CaptureTextClickResult:SetText(" ");
      WowkemonCaptureFrame.CaptureTextClickResult:SetPoint("TOP",WowkemonCaptureFrame,"TOP",0,-200)
      WowkemonCaptureFrame.CaptureTextClickResult:SetTextHeight(15)
      WowkemonCaptureFrame.CaptureTextHitResult = WowkemonCaptureFrame.TextLayer:CreateFontString(nil,"OVERLAY","GameFontNormal")
      WowkemonCaptureFrame.CaptureTextHitResult:SetText(" ");
      WowkemonCaptureFrame.CaptureTextHitResult:SetPoint("TOP",WowkemonCaptureFrame,"TOP",0,-50)
      WowkemonCaptureFrame.CaptureTextHitResult:SetTextHeight(15)
      WowkemonCaptureFrame.CaptureItem = CreateFrame("Frame","CaptureItemFrame",WowkemonCaptureFrame)
      WowkemonCaptureFrame.CaptureItem:SetSize(50,50)
      WowkemonCaptureFrame.CaptureItem:SetPoint("BOTTOMRIGHT",WowkemonCaptureFrame,"BOTTOMRIGHT",-20,20)
      WowkemonCaptureFrame.CaptureItem:SetScript("OnUpdate", function () WowkemonCaptureFrame.CubeTextureColor:SetColorTexture((CaptureEventTime*2),(1-(CaptureEventTime*2)),0,1) end)
      WowkemonCaptureFrame.CubeTextureColor = WowkemonCaptureFrame.CaptureItem:CreateTexture(nil,"BACKGROUND",nil,1)
      WowkemonCaptureFrame.CubeTextureColor:SetPoint("CENTER")
      WowkemonCaptureFrame.CubeTextureColor:SetSize(WowkemonCaptureFrame.CaptureItem:GetSize())
      WowkemonCaptureFrame.CubeTextureColor:SetColorTexture(1,1,1,1)
      WowkemonCaptureFrame.CaptureItem.Texture = WowkemonCaptureFrame.CaptureItem:CreateTexture(nil,"BACKGROUND",nil,2)
      WowkemonCaptureFrame.CaptureItem.Texture:SetSize(WowkemonCaptureFrame.CaptureItem:GetSize())
      WowkemonCaptureFrame.CaptureItem.Texture:SetPoint("CENTER")
      WowkemonCaptureFrame.CaptureItem.Texture:SetTexture(WDir.."\\resources\\textures\\misc\\wowkeCube.tga")
        WowkemonCaptureFrame.CaptureItemButton = CreateFrame("Button","CaptureItemButton",WowkemonCaptureFrame.CaptureItem)
        WowkemonCaptureFrame.CaptureItemButton:SetSize(WowkemonCaptureFrame.CaptureItem:GetSize())
        WowkemonCaptureFrame.CaptureItemButton:SetPoint("CENTER")
        WowkemonCaptureFrame.CaptureItemButton:SetScript("OnClick", function() CubeClicked(CaptureEventTime); end)
        WowkemonCaptureFrame.closeButton = CreateFrame("Button","CaptureFrameCloseBtn",WowkemonCaptureFrame,"UIPanelButtonTemplate")
        WowkemonCaptureFrame.closeButton:SetWidth(100)
        WowkemonCaptureFrame.closeButton:SetHeight(30)
        WowkemonCaptureFrame.closeButton:SetFrameLevel(5)
        WowkemonCaptureFrame.closeButton:SetPoint("BOTTOM",WowkemonCaptureFrame,"BOTTOM",0,30)
        WowkemonCaptureFrame.closeButton:SetText("Close")
        WowkemonCaptureFrame.closeButton:SetScript("OnClick", function () StopMusic() WildWowkemonIsAvailable = false CaptureWindowLive = false; openMainWowkedexPanel()  unlockCubeClick() WowkemonCaptureFrame.Wowkemon:SetScale(1); WowkemonCaptureFrame.closeButton:Hide(); WowkemonCaptureFrame.abortButton:Show(); clearFeedbackText(); WowkemonCaptureFrame:Hide(); WowkemonCubeButtonLock = false; end)
        WowkemonCaptureFrame.closeButton:Hide();
       WowkemonCaptureFrame:Hide()
        WowkemonCaptureFrame.abortButton = CreateFrame("Button","CaptureFrameAbortBtn",WowkemonCaptureFrame,"UIPanelButtonTemplate")
        WowkemonCaptureFrame.abortButton:SetWidth(100)
        WowkemonCaptureFrame.abortButton:SetHeight(30)
        WowkemonCaptureFrame.abortButton:SetFrameLevel(5)
        WowkemonCaptureFrame.abortButton:SetPoint("BOTTOM",WowkemonCaptureFrame,"BOTTOM",0,-30)
        WowkemonCaptureFrame.abortButton:SetText("Leave")
        WowkemonCaptureFrame.abortButton:SetScript("OnClick", function () StopMusic() WildWowkemonIsAvailable = false CaptureWindowLive = false; openMainWowkedexPanel() unlockCubeClick() WowkemonCaptureFrame.closeButton:Hide(); WowkemonCaptureFrame.abortButton:Show(); clearFeedbackText(); WowkemonCaptureFrame:Hide(); WowkemonCubeButtonLock = false; end)
    --  WowkemonCaptureFrame.Wowkemon:SetColorTexture(0,1,0,1)
        WowkemonCaptureFrame.AmmoTexture = WowkemonCaptureFrame.InnerFrame:CreateTexture(nil,"OVERLAY")
        WowkemonCaptureFrame.AmmoTexture:SetTexture(WDir.."\\resources\\textures\\misc\\wowkeCube.tga")
          WowkemonCaptureFrame.AmmoTexture:SetSize(10,10)
        WowkemonCaptureFrame.AmmoTexture:SetPoint("BOTTOMLEFT",WowkemonCaptureFrame,"BOTTOMLEFT",15,15)
        WowkemonCaptureFrame.AmmoAmount = WowkemonCaptureFrame.TextLayer:CreateFontString(nil,"OVERLAY","GameFontHighlight")
        WowkemonCaptureFrame.AmmoAmount:SetHeight(5)
        WowkemonCaptureFrame.AmmoAmount:SetPoint("BOTTOMLEFT",WowkemonCaptureFrame,"BOTTOMLEFT",30,18)
  --      WowkemonCaptureFrame.AmmoAmount:SetText("x "..WowkemonPlayerData["Cubes"])
        WowkemonCaptureFrame.TextLayer:SetScript("OnUpdate",function() WowkemonCaptureFrame.AmmoAmount:SetText("x "..WowkemonPlayerData["Capture Cube"]); end)



---  60 * facingvalue = inversed rotation

--function printData()
--print(GetPlayerFacing())
--end


--
-- IF PLAYER Y > WOWKEMON Y = true (Player is below target)
      -- playerdirection is between 0 and 90 or 270 and 360  then target is facing.
          -- PLAYER Y - WOWKEMON Y = distance from target


-- DELAY FUNCTION
local waitTable = {};
local waitFrame = nil;

function Wowkemon__wait(delay, func, ...)
  if(type(delay)~="number" or type(func)~="function") then
    return false;
  end
  if(waitFrame == nil) then
    waitFrame = CreateFrame("Frame","WaitFrame", UIParent);
    waitFrame:SetScript("onUpdate",function (self,elapse)
      local count = #waitTable;
      local i = 1;
      while(i<=count) do
        local waitRecord = tremove(waitTable,i);
        local d = tremove(waitRecord,1);
        local f = tremove(waitRecord,1);
        local p = tremove(waitRecord,1);
        if(d>elapse) then
          tinsert(waitTable,i,{d-elapse,f,p});
          i = i + 1;
        else
          count = count - 1;
          f(unpack(p));
        end
      end
    end);
  end
  tinsert(waitTable,{delay,func,{...}});
  return true;
end


-- ADD ITEM FUNCTION
function WowkemonAddItem(inItem,inAmount)
  if inItem ~= nil then
print("|cffFFff00  Wowkemon: You received "..inAmount.."x "..inItem.."|r")
WowkemonPlayerData[inItem] = WowkemonPlayerData[inItem] + inAmount;
end
end


function progressTutorial(tut,stage) -- Explicit tutorial function. called during tutorial to advance the stages.
tutorialStatuses[tut] = stage
end

function WowkemonDispatchMultiFunction(funcs,args)
for f in pairs(funcs) do
local funcToCall = funcs[f]
--  for a in pairs(args) do
    local arg1 = args[f][1]
    local arg2 = args[f][2]
  funcToCall(arg1,arg2);
-- end
end
end
